commit a75d15db70bf5f37cdbfa7e5fc61adb35c702bd6
Author: Jeff Law <jeffrey.law@oss.qualcomm.com>
Date:   Wed Dec 31 06:52:03 2025

    [RISC-V][PR target/121485] Fix mode on Zvkned lmul extending patterns
    
    This fixes the mode on the lmul-extending variants of various Zvkned patterns.
    
    Essentially vsetvl insertion depends on the mode of each insn and for lmul
    extending patterns, we need the larger mode, not the smaller one to get the
    correct vsetvls.
    
    Tested on riscv{32,64}-elf on the simple testcase in the PR.  I also verified
    the larger testcase in godbolt appears to work correctly.
    
    Waiting on upstream CI before committing.
    
            PR target/121485
    gcc/
            * config/riscv/vector-crypto.md: Fix mode attribute for the
            lmul extending Zvkned patterns.
    
    gcc/testsuite/
            * gcc.target/riscv/rvv/vsetvl/pr121485.c: New test.

diff --git a/gcc/testsuite/gcc.target/riscv/rvv/vsetvl/pr121485.c b/gcc/testsuite/gcc.target/riscv/rvv/vsetvl/pr121485.c
new file mode 100644
index 00000000000..2e066765211
--- /dev/null
+++ b/gcc/testsuite/gcc.target/riscv/rvv/vsetvl/pr121485.c
@@ -0,0 +1,13 @@
+/* { dg-do compile } */
+/* { dg-options "-march=rv64gcv_zvkned -mabi=lp64d" { target rv64 } } */
+/* { dg-options "-march=rv32gcv_zvkned -mabi=ilp32" { target rv32 } } */
+
+#include <riscv_vector.h>
+
+vuint32m4_t test_riscv_vaesz_vs_u32m1_u32m4(vuint32m4_t a, vuint32m1_t b, int vl)
+{
+  return __riscv_vaesz_vs_u32m1_u32m4(a, b, vl);
+}
+
+
+/* { dg-final { scan-assembler {vsetvli\szero,[a-x0-9]+,e32,m4,ta,ma} } } */

